namespace org.accordproject.templatemark;
using org.accordproject.commonmark;
using AccordProject.Concerto.Metamodel;
using AccordProject.Concerto;
[System.Text.Json.Serialization.JsonConverter(typeof(System.Text.Json.Serialization.JsonStringEnumConverter))]
public enum CodeType {
      ES_2020,
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.templatemark", Version = "0.4.0", Name = "Code")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class Code : Concept {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.templatemark@0.4.0.Code";
   public CodeType type { get; set; }
   public string contents { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.templatemark", Version = "0.4.0", Name = "ElementDefinition")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public abstract class ElementDefinition : Child {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.templatemark@0.4.0.ElementDefinition";
   public string name { get; set; }
   public string elementType { get; set; }
   public Decorator?[] decorators { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.templatemark", Version = "0.4.0", Name = "VariableDefinition")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class VariableDefinition : ElementDefinition {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.templatemark@0.4.0.VariableDefinition";
   public string identifiedBy { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.templatemark", Version = "0.4.0", Name = "FormattedVariableDefinition")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class FormattedVariableDefinition : VariableDefinition {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.templatemark@0.4.0.FormattedVariableDefinition";
   public string format { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.templatemark", Version = "0.4.0", Name = "EnumVariableDefinition")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class EnumVariableDefinition : VariableDefinition {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.templatemark@0.4.0.EnumVariableDefinition";
   public string[] enumValues { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.templatemark", Version = "0.4.0", Name = "FormulaDefinition")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class FormulaDefinition : ElementDefinition {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.templatemark@0.4.0.FormulaDefinition";
   public string[] dependencies { get; set; }
   public Code code { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.templatemark", Version = "0.4.0", Name = "BlockDefinition")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public abstract class BlockDefinition : ElementDefinition {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.templatemark@0.4.0.BlockDefinition";
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.templatemark", Version = "0.4.0", Name = "ClauseDefinition")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class ClauseDefinition : BlockDefinition {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.templatemark@0.4.0.ClauseDefinition";
   public Code? condition { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.templatemark", Version = "0.4.0", Name = "ContractDefinition")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class ContractDefinition : BlockDefinition {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.templatemark@0.4.0.ContractDefinition";
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.templatemark", Version = "0.4.0", Name = "WithDefinition")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class WithDefinition : BlockDefinition {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.templatemark@0.4.0.WithDefinition";
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.templatemark", Version = "0.4.0", Name = "ConditionalDefinition")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class ConditionalDefinition : BlockDefinition {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.templatemark@0.4.0.ConditionalDefinition";
   public Child[] whenTrue { get; set; }
   public Child[] whenFalse { get; set; }
   public Code? condition { get; set; }
   public string[] dependencies { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.templatemark", Version = "0.4.0", Name = "OptionalDefinition")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class OptionalDefinition : BlockDefinition {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.templatemark@0.4.0.OptionalDefinition";
   public Child[] whenSome { get; set; }
   public Child[] whenNone { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.templatemark", Version = "0.4.0", Name = "JoinDefinition")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class JoinDefinition : BlockDefinition {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.templatemark@0.4.0.JoinDefinition";
   public string separator { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.templatemark", Version = "0.4.0", Name = "ListBlockDefinition")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class ListBlockDefinition : BlockDefinition {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.templatemark@0.4.0.ListBlockDefinition";
   public string type { get; set; }
   public string tight { get; set; }
   public string start { get; set; }
   public string delimiter { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.templatemark", Version = "0.4.0", Name = "ForeachBlockDefinition")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class ForeachBlockDefinition : BlockDefinition {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.templatemark@0.4.0.ForeachBlockDefinition";
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.templatemark", Version = "0.4.0", Name = "WithBlockDefinition")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class WithBlockDefinition : BlockDefinition {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.templatemark@0.4.0.WithBlockDefinition";
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.templatemark", Version = "0.4.0", Name = "ConditionalBlockDefinition")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class ConditionalBlockDefinition : BlockDefinition {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.templatemark@0.4.0.ConditionalBlockDefinition";
   public Child[] whenTrue { get; set; }
   public Child[] whenFalse { get; set; }
   public Code? condition { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.templatemark", Version = "0.4.0", Name = "OptionalBlockDefinition")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class OptionalBlockDefinition : BlockDefinition {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.templatemark@0.4.0.OptionalBlockDefinition";
   public Child[] whenSome { get; set; }
   public Child[] whenNone { get; set; }
}
